require 'dotpack/repo'

module Dotpack
  class Package
    attr_reader :path
    
    @packages = nil

    def self.all
      return @packages unless @packages.nil?
      repos = Repo.all
      packages = repos.map{|x| Dir[x.path + "/*"]}.flatten
      packages.select!{|x| File.exist? x + "/Dotpackfile"}
      @packages = packages.map{|x| Package.new(x)}
      @packages
    end

    private
    def initialize(path)
      @path = path
    end
  end
end
